class Modellbauservo
{
  private:
    int WMIN = 1000;
    int WMITTE = 1500;
    int WMAX = 2000;
    int SCHRITTE = 1000;
//Mode 8
//Phasen- und Frequenz-korrekt
//WGM1   3 2 1 0
//       1 0 0 0
//ICR1=..... TOP
//fpwm = fclk/(2*N*TOP)
//Vorteilung
//N=8
//80Hz = 16000000/(2*8*TOP)
//TOP = 16000000/(2*8*80Hz)=12500
//dt==1000ms*(1/80Hz)/12500 == 0,001ms (1 Schritt == 0,001ms)
//=>
//1ms == 1000 Schritte
//1,5ms == 1500 Schritte
//2ms == 2000 Schritte
  public: 
  void start() 
  {
       TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0)
              | (0<<COM1C1) | (0<<COM1C0) | (0<<WGM11) | (0<<WGM10);
       TCCR1B = (0<<ICNC1) | (0<<ICES1) | (1<<WGM13) | (0<<WGM12) | (0<<CS12) | (1<<CS11) | (0<<CS10); //Vort. 8, s.S. 135       
       ICR1=12500;       
       DDRB |= (1<<PB5); //OCR1A
       DDRB |= (1<<PB6); //OCR1B
       OCR1A = WMITTE; //PWM-Breite auf Mitte setzen.  
       OCR1B = WMITTE; //PWM-Breite auf Mitte setzen.  
   }

   /**
    *   wert: 1000...2000 für Winkel +/- 45Grad
    *   wert:  500...2500 für Winkel +/- 90Grad
    *   
    *   Servor 1 an digital Pin 9
    */
   void setzePWMservo1(int wert)
   {
       OCR1A = wert;
   }
   
   /**
    *   wert: 1000...2000 für Winkel +/- 45Grad
    *   wert:  500...2500 für Winkel +/- 90Grad
    *   
    *   Servor 2 an digital Pin 10
    */
   void setzePWMservo2(int wert)
   {
       OCR1B = wert;
   }

   /*
    *   winkel: +/90 Grad
    */
   void setzeWINKELservo1(float winkel)
   {
       int wert = (int)(500.5 + 2000.0*((winkel+90.0)/180.0));
       setzePWMservo1(wert);
   }

};
